gtkmm: Gtk::EventController Class Reference

gtkmm 4.22.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::EventController Class Reference
Event Controllers and Gestures

Self-contained handler of series of events. More...

`#include <gtkmm/eventcontroller.h>`

Inheritance diagram for Gtk::EventController:
[legend]

## Public Member Functions
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject.
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Widget * | get_widget ()
| Returns the Gtk::Widget this controller relates to.
const Widget * | get_widget () const
| Returns the Gtk::Widget this controller relates to.
void | reset ()
| Resets the controller to a clean state.
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events.
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events.
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller.
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller.
Glib::ustring | get_name () const
| Gets the name of controller.
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging.
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller.
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller.
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller.
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller.
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller.
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle.
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle.
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle.
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Self-contained handler of series of events.

This is an abstract base class, low-level implementation for event controllers. Those react to a series of Gdk::Events, and possibly trigger actions as a consequence of those.

Since gtkmm 3.14

## Constructor & Destructor Documentation

## ◆ EventController() [1/2]

Gtk::EventController::EventController | ( | EventController && | src | ) |
| noexcept

## ◆ ~EventController()

Gtk::EventController::~EventController | ( |  | ) |
| overridenoexcept

## ◆ EventController() [2/2]

Gtk::EventController::EventController | ( |  | ) |
| protected

There is no create() method that corresponds to this constructor, because only derived classes shall be created.

## Member Function Documentation

## ◆ get_current_event()

Glib::RefPtr< const Gdk::Event > Gtk::EventController::get_current_event | ( |  | ) | const

Returns the event that is currently being handled by the controller.

At other times, nullptr is returned.

Returns
  The event that is currently handled by controller.

## ◆ get_current_event_device() [1/2]

Glib::RefPtr< Gdk::Device > Gtk::EventController::get_current_event_device | ( |  | ) |

Returns the device of the event that is currently being handled by the controller.

At other times, nullptr is returned.

Returns
  Device of the event is currently handled by controller.

## ◆ get_current_event_device() [2/2]

Glib::RefPtr< const Gdk::Device > Gtk::EventController::get_current_event_device | ( |  | ) | const

Returns the event that is currently being handled by the controller.

At other times, nullptr is returned.

Returns
  The event that is currently handled by controller.

## ◆ get_current_event_state()

Gdk::ModifierType Gtk::EventController::get_current_event_state | ( |  | ) | const

Returns the modifier state of the event that is currently being handled by the controller.

At other times, 0 is returned.

Returns
  Modifier state of the event is currently handled by controller.

## ◆ get_current_event_time()

guint32 Gtk::EventController::get_current_event_time | ( |  | ) | const

Returns the timestamp of the event that is currently being handled by the controller.

At other times, 0 is returned.

Returns
  Timestamp of the event is currently handled by controller.

## ◆ get_name()

Glib::ustring Gtk::EventController::get_name | ( |  | ) | const

Gets the name of controller.

Returns
  The controller name.

## ◆ get_propagation_limit()

PropagationLimit Gtk::EventController::get_propagation_limit | ( |  | ) | const

Gets the propagation limit of the event controller.

Returns
  The propagation limit.

## ◆ get_propagation_phase()

PropagationPhase Gtk::EventController::get_propagation_phase | ( |  | ) | const

Gets the propagation phase at which controller handles events.

Returns
  The propagation phase.

## ◆ get_type()

GType Gtk::EventController::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_widget() [1/2]

Widget * Gtk::EventController::get_widget | ( |  | ) |

Returns the Gtk::Widget this controller relates to.

Returns
  A Gtk::Widget.

## ◆ get_widget() [2/2]

const Widget * Gtk::EventController::get_widget | ( |  | ) | const

Returns the Gtk::Widget this controller relates to.

Returns
  A Gtk::Widget.

## ◆ gobj() [1/2]

GtkEventController * Gtk::EventController::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkEventController * Gtk::EventController::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkEventController * Gtk::EventController::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

EventController & Gtk::EventController::operator= | ( | EventController && | src | ) |
| noexcept

## ◆ property_name() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::EventController::property_name | ( |  | ) |

The name for this controller, typically used for debugging purposes.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_name() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::EventController::property_name | ( |  | ) | const

The name for this controller, typically used for debugging purposes.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagation_limit() [1/2]

Glib::PropertyProxy< PropagationLimit > Gtk::EventController::property_propagation_limit | ( |  | ) |

The limit for which events this controller will handle.

Default value: Gtk::PropagationLimit::SAME_NATIVE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagation_limit() [2/2]

Glib::PropertyProxy_ReadOnly< PropagationLimit > Gtk::EventController::property_propagation_limit | ( |  | ) | const

The limit for which events this controller will handle.

Default value: Gtk::PropagationLimit::SAME_NATIVE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagation_phase() [1/2]

Glib::PropertyProxy< PropagationPhase > Gtk::EventController::property_propagation_phase | ( |  | ) |

The propagation phase at which this controller will handle events.

Default value: Gtk::PropagationPhase::BUBBLE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagation_phase() [2/2]

Glib::PropertyProxy_ReadOnly< PropagationPhase > Gtk::EventController::property_propagation_phase | ( |  | ) | const

The propagation phase at which this controller will handle events.

Default value: Gtk::PropagationPhase::BUBBLE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_widget()

Glib::PropertyProxy_ReadOnly< Widget * > Gtk::EventController::property_widget | ( |  | ) | const

The widget receiving the Gdk::Events that the controller will handle.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ reset()

void Gtk::EventController::reset | ( |  | ) |

Resets the controller to a clean state.

## ◆ set_name()

void Gtk::EventController::set_name | ( | const Glib::ustring & | name | ) |

Sets a name on the controller that can be used for debugging.

Parameters

  name | A name for controller.

## ◆ set_propagation_limit()

void Gtk::EventController::set_propagation_limit | ( | PropagationLimit | limit | ) |

Sets the event propagation limit on the event controller.

If the limit is set to Gtk::PropagationLimit::SAME_NATIVE, the controller won't handle events that are targeted at widgets on a different surface, such as popovers.

Parameters

  limit | The propagation limit.

## ◆ set_propagation_phase()

void Gtk::EventController::set_propagation_phase | ( | PropagationPhase | phase | ) |

Sets the propagation phase at which a controller handles events.

If phase is Gtk::PropagationPhase::NONE, no automatic event handling will be performed, but other additional gesture maintenance will.

Parameters

  phase | A propagation phase.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::EventController > wrap | ( | GtkEventController * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.